/*
 * frmHipotecar.java
 *
 * Created on 18 de agosto de 2008, 23:33
 */

package pmicrovenus;

import java.util.ArrayList;
import java.util.Vector;
import javax.swing.JOptionPane;

/**
 *
 * @author  Manel
 */
public class frmHipotecar extends javax.swing.JFrame {

     Tablero tablero;
    /** Creates new form frmHipotecar */
    public frmHipotecar(Tablero t) {
        initComponents();
        this.tablero = t;
        this.setTitle(tablero.getJugadorActual().getNombre() + " (Hipotecar/Deshipotecar)");
        this.obtenerPropiedadesDeshipotecables();
        this.obtenerPropiedadesHipotecables();
        this.jTabbedPane1.addTab("Hipotecar", this.jPanel1);
        this.jTabbedPane1.addTab("Deshipotecar", this.jPanel2);
//        this.jTabbedPane1.setTitleAt(1, "Hipotecar");
//        this.jTabbedPane1.setTitleAt(2, "Deshipotecar");
    }
    
    
    public void obtenerPropiedadesHipotecables(){
     Jugador j = tablero.getJugadorActual();
    
    ArrayList misPropiedadesHipotecables = new ArrayList(j.getPropiedadesHipotecables().size());
        for (int i=0;i<j.getPropiedadesHipotecables().size();i++){
            misPropiedadesHipotecables.add(i,j.getPropiedadesHipotecables().get(i).getDescripcion());
        }
        this.jlstHipotecar.setListData(misPropiedadesHipotecables.toArray());
        this.jtxtDetalleH.setVisible(false);
        this.jtxtDetalleH.setText("");
}
    public void obtenerPropiedadesDeshipotecables(){
     Jugador j = tablero.getJugadorActual();
    
    Vector misPropiedadesDeshipotecables = new Vector(j.getPropiedadesHipotecadas().size());
        for (int i=0;i<j.getPropiedadesHipotecadas().size();i++){
            misPropiedadesDeshipotecables.add(i,j.getPropiedadesHipotecadas().get(i).getDescripcion());
        }
        this.jlstDeshipotecar.setListData(misPropiedadesDeshipotecables.toArray());
        this.jtxtDetalleD.setVisible(false);
        this.jtxtDetalleD.setText("");
}

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jbtnCerrar = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jbtnDeshipotecar = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jlstDeshipotecar = new javax.swing.JList();
        jScrollPane4 = new javax.swing.JScrollPane();
        jtxtDetalleD = new javax.swing.JTextPane();
        jlblSolarSelD = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jbtnHipotecar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jlstHipotecar = new javax.swing.JList();
        jScrollPane3 = new javax.swing.JScrollPane();
        jtxtDetalleH = new javax.swing.JTextPane();
        jlblSolarSelH = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);

        jbtnCerrar.setText("Cerrar");
        jbtnCerrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCerrarActionPerformed(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Deshipotecar", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14))); // NOI18N

        jbtnDeshipotecar.setText("Deshipotecar");
        jbtnDeshipotecar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnDeshipotecarActionPerformed(evt);
            }
        });

        jlstDeshipotecar.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jlstDeshipotecar.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jlstDeshipotecar.setPreferredSize(new java.awt.Dimension(35, 80));
        jlstDeshipotecar.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jlstDeshipotecarValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(jlstDeshipotecar);

        jtxtDetalleD.setEditable(false);
        jScrollPane4.setViewportView(jtxtDetalleD);

        jlblSolarSelD.setFont(new java.awt.Font("Tahoma", 1, 14));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                        .addGap(67, 67, 67)
                        .addComponent(jlblSolarSelD, javax.swing.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                        .addGap(45, 45, 45)
                        .addComponent(jbtnDeshipotecar))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 179, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 197, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addComponent(jlblSolarSelD, javax.swing.GroupLayout.PREFERRED_SIZE, 12, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jbtnDeshipotecar))
        );

        jTabbedPane1.addTab("tab2", jPanel2);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Hipotecar", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14))); // NOI18N

        jbtnHipotecar.setText("Hipotecar");
        jbtnHipotecar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnHipotecarActionPerformed(evt);
            }
        });

        jlstHipotecar.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jlstHipotecar.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jlstHipotecar.setPreferredSize(new java.awt.Dimension(35, 80));
        jlstHipotecar.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jlstHipotecarValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jlstHipotecar);

        jtxtDetalleH.setEditable(false);
        jScrollPane3.setViewportView(jtxtDetalleH);

        jlblSolarSelH.setFont(new java.awt.Font("Tahoma", 1, 14));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(44, 44, 44)
                        .addComponent(jbtnHipotecar, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 182, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addContainerGap(138, Short.MAX_VALUE)
                        .addComponent(jlblSolarSelH, javax.swing.GroupLayout.PREFERRED_SIZE, 266, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(jlblSolarSelH, javax.swing.GroupLayout.DEFAULT_SIZE, 9, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 213, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jbtnHipotecar))
        );

        jTabbedPane1.addTab("tab1", jPanel1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(326, 326, 326)
                        .addComponent(jbtnCerrar))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 318, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(jbtnCerrar)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void jbtnHipotecarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnHipotecarActionPerformed
    Jugador j = tablero.getJugadorActual();
    
   if (!this.jlstHipotecar.isSelectionEmpty()){
        String propiedad = this.jlstHipotecar.getSelectedValue().toString();
        Casilla c =  j.getPropiedad(propiedad);
        String mens = "Has hipotecado "+ propiedad + "\n"+
                "Recibes " + c.getValorHipoteca() + " ";
        
        String tit = j.getNombre();
        JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);

        j.getPropiedad(propiedad).hipotecar();
   }
    
     
     this.obtenerPropiedadesHipotecables();
     this.obtenerPropiedadesDeshipotecables();
}//GEN-LAST:event_jbtnHipotecarActionPerformed

private void jbtnCerrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCerrarActionPerformed
// TODO add your handling code here:
     //this.setVisible(false);
     this.dispose();
}//GEN-LAST:event_jbtnCerrarActionPerformed

private void jbtnDeshipotecarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnDeshipotecarActionPerformed
    Jugador j = tablero.getJugadorActual();
    
   if (!this.jlstDeshipotecar.isSelectionEmpty()){
        String propiedad = this.jlstDeshipotecar.getSelectedValue().toString();
        Casilla c =  j.getPropiedad(propiedad);
        String mens = "Has deshipotecado "+ propiedad + "\n"+
                "por " + (c.getValorHipoteca() + c.getValorHipoteca() * 0.1f  ) + " ";
        String tit = j.getNombre();
        JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);

        c.deshipotecar();
   }
    
     
     this.obtenerPropiedadesHipotecables();
     this.obtenerPropiedadesDeshipotecables();
}//GEN-LAST:event_jbtnDeshipotecarActionPerformed

private void jlstDeshipotecarValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jlstDeshipotecarValueChanged
// TODO add your handling code here:
      Jugador j = tablero.getJugadorActual();
    
   if (!this.jlstDeshipotecar.isSelectionEmpty()){
        String desc = this.jlstDeshipotecar.getSelectedValue().toString();
        //SOLAR
        if(j.tieneSolar(desc)){
            Solar s=j.getSolar(desc);
            float valor = (s.getValorHipoteca() + s.getValorHipoteca() * 0.1f);
            this.jtxtDetalleD.setVisible(true);
            String detalle;
            detalle=" Color: " + s.getColor()+"\n"+
            " Precio Casa: " + s.getPrecioCasa()+"\n"+
            " Precio Hotel: " + s.getPrecioHotel()+"\n"+
            " Renta sin casas: " + s.getRenta(0)+"\n"+
            " Renta 1 casa: " +s.getRenta(1)+"\n"+
            " Renta 2 casas: " + s.getRenta(2)+"\n"+
            " Renta 3 casas: " + s.getRenta(3)+"\n"+
            " Renta 4 casas: " + s.getRenta(4)+"\n"+
            " Renta Hotel: " + s.getRenta(5)+"\n"+
            " Valor Hipoteca: " + valor;
            
            if (s.getNCasas()<5) detalle = (detalle + "\nNumero de casas: "+ s.getNCasas());
//            if (s.getNCasas()==5) detalle.concat("Tiene un Hotel");
            this.jtxtDetalleD.setText(detalle);
            this.jlblSolarSelD.setText(s.getDescripcion()+ " por "+ valor + " ");
        }
        
            
             //SERVICIO
        if (j.tieneServicio(desc)){
            this.jtxtDetalleD.setVisible(true);
            String detalle="";
            Servicio sp = (Servicio) j.getPropiedad(desc);
            float valor = (sp.getValorHipoteca() + sp.getValorHipoteca() * 0.1f);
            detalle=" Precio: " + sp.getPrecioCompra()+"\n"+
            " Renta: " +sp.getRenta()+"\n"+
            " Valor Hipoteca " + valor;
            this.jtxtDetalleD.setText(detalle);
        }
        //ESTACION
        if (j.tieneEstacion(desc)){
           this.jtxtDetalleD.setVisible(true);
            String detalle="";
            Estacion es = (Estacion) j.getPropiedad(desc);
            float valor = (es.getValorHipoteca() + es.getValorHipoteca() * 0.1f);
            detalle=" Precio: " + es.getPrecioCompra()+"\n"+
            " Renta: " +es.getRenta()+"\n"+
            " Valor Hipoteca " + valor;
            this.jtxtDetalleD.setText(detalle);
        }
            
            
               }  
}//GEN-LAST:event_jlstDeshipotecarValueChanged

private void jlstHipotecarValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jlstHipotecarValueChanged
// TODO add your handling code here:
        Jugador j = tablero.getJugadorActual();
    
   if (!this.jlstHipotecar.isSelectionEmpty()){
        String desc = this.jlstHipotecar.getSelectedValue().toString();
        if (j.tieneSolar(desc)){
            this.jtxtDetalleH.setVisible(true);
            Solar s=j.getSolar(desc);
            String detalle;
            detalle=" Color: " + s.getColor()+"\n"+
            " Precio Casa: " + s.getPrecioCasa()+"\n"+
            " Precio Hotel: " + s.getPrecioHotel()+"\n"+
            " Renta sin casas: " + s.getRenta(0)+"\n"+
            " Renta 1 casa: " +s.getRenta(1)+"\n"+
            " Renta 2 casas: " + s.getRenta(2)+"\n"+
            " Renta 3 casas: " + s.getRenta(3)+"\n"+
            " Renta 4 casas: " + s.getRenta(4)+"\n"+
            " Renta Hotel: " + s.getRenta(5)+"\n"+
            " Valor Hipoteca " + s.getValorHipoteca();
            
            if (s.getNCasas()<5) detalle = (detalle + "\nNumero de casas: "+ s.getNCasas());
//            if (s.getNCasas()==5) detalle.concat("Tiene un Hotel");
            this.jtxtDetalleH.setText(detalle);
            this.jlblSolarSelH.setText(s.getDescripcion());
            this.jlblSolarSelH.setText(s.getDescripcion()+ " por "+ s.getValorHipoteca()+ " ");
        }
        
        //SERVICIO
        if (j.tieneServicio(desc)){
            this.jtxtDetalleH.setVisible(true);
            String detalle="";
            Servicio sp = (Servicio) j.getPropiedad(desc);
            detalle=" Precio: " + sp.getPrecioCompra()+"\n"+
            " Renta: " +sp.getRenta()+"\n"+
            " Valor Hipoteca " + sp.getValorHipoteca();
            this.jtxtDetalleH.setText(detalle);
        }
        //ESTACION
        if (j.tieneEstacion(desc)){
           this.jtxtDetalleH.setVisible(true);
            String detalle="";
            Estacion es = (Estacion) j.getPropiedad(desc);
            detalle=" Precio: " + es.getPrecioCompra()+"\n"+
            " Renta: " +es.getRenta()+"\n"+
            " Valor Hipoteca " + es.getValorHipoteca();
            this.jtxtDetalleH.setText(detalle);
        }
         
   }
}//GEN-LAST:event_jlstHipotecarValueChanged

    /**
    * @param args the command line arguments
    */


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jbtnCerrar;
    private javax.swing.JButton jbtnDeshipotecar;
    private javax.swing.JButton jbtnHipotecar;
    private javax.swing.JLabel jlblSolarSelD;
    private javax.swing.JLabel jlblSolarSelH;
    private javax.swing.JList jlstDeshipotecar;
    private javax.swing.JList jlstHipotecar;
    private javax.swing.JTextPane jtxtDetalleD;
    private javax.swing.JTextPane jtxtDetalleH;
    // End of variables declaration//GEN-END:variables

}
